Subject: Re: Bug in 2.26: git-fetch fetching too many objects?

From: "Dixit, Ashutosh" <[email-masked]>
Date: Mon, 20 Apr 2020 22:18:58 -0700

On Mon, 20 Apr 2020 10:03:01 -0700, Konstantin Ryabitsev wrote:
>
> On Mon, Apr 20, 2020 at 08:44:39AM -0700, Dixit, Ashutosh wrote:
> > I am seeing a strange behavior in git-fetch in 2.26. I frequently fetch
> > from a couple of linux kernel remotes (so you will have an idea how big the
> > repo is). I have a different system with 2.20 on which I never see a
> > problem.
> >
> > So let us say I fetch with 2.20 and it fetches say 20,000 objects. However
> > with 2.26 it starts fetching millions of objects, objects which are already
> > present locally. I don't know yet if this happens each time or only once in
> > a while, I have seen it happen twice, will keep an eye out for this.
> >
> > If you open a bug please let me know and I can update it with my
> > findings. Unless it is a known issue, perhaps already fixed?
>
> It's a known issue with protocol v2, but nobody's been able to properly
> reproduce it in order to debug. If you can reliably make it reoccur,
> then please make a copy of your local tree and share with this list,
> together with your gitconfig and the remote you're pulling.
>
> Setting protocol.version=1 should fix it, but if you are willing to help
> troubleshoot it, a bunch of people will be super thankful to you for
> that, as it affects quite a number of kernel developers.

I will see what I can do. I think I am seeing an instance where a branch
has incorrect SHA's during the clone itself but I haven't been able to
reproduce it after the HEAD moved at the remote. I'll report back if I have
a reliable reproducer. Thanks!